Loading...
Searching...
No Matches
EST_Relation Class Reference

`#include <include/ling_class/EST_Relation.h>`

Collaboration diagram for EST_Relation:
[legend]

## Public Types

typedef EST_Relation_Iterator | Iterator

## Public Member Functions

| EST_Relation ()
| EST_Relation (const EST_String &name)
| EST_Relation (const EST_Relation &r)
| ~EST_Relation ()
void | evaluate_item_features ()
void | clear ()
EST_Utterance * | utt (void)
void | set_utt (EST_Utterance *u)
const EST_String & | name () const
EST_Item * | head () const
EST_Item * | root () const
EST_Item * | tail () const
EST_Item * | first () const
EST_Item * | rlast () const
int | length () const
int | empty () const
void | remove_item (EST_Item *item)
void | remove_item_feature (const EST_String &name)
EST_read_status | load (const EST_String &filename, const EST_String &type="esps")
EST_read_status | load (EST_TokenStream &ts, const EST_TVector< EST_Item_Content * > &contents)
EST_read_status | load (const EST_String &filename, EST_TokenStream &ts, const EST_String &type)
EST_write_status | save (const EST_String &filename, bool evaluate_ff=false) const
EST_write_status | save (const EST_String &filename, const EST_String &type, bool evaluate_ff=false) const
EST_write_status | save (ostream &outf, EST_TKVL< void *, int > contents) const
EST_write_status | save (ostream &outf, const EST_String &type, bool evaluate_ff) const
EST_Relation & | operator= (const EST_Relation &s)
EST_Item * | append (EST_Item *si)
EST_Item * | append ()
EST_Item * | prepend (EST_Item *si)
EST_Item * | prepend ()

## Public Attributes

EST_Features | f

## Friends

class | EST_Item
ostream & | operator<< (ostream &s, const EST_Relation &u)

## Detailed Description

Relations are a container class for EST_Items. Three types of relation structure are supported:

<variablelist>

<varlistentry>Linear lists<listitem></listitem></varlistentry> <varlistentry>Trees<listitem></listitem></varlistentry> <varlistentry>Multi-linear structures<listitem> as used in autosegmental phonology etc</listitem></varlistentry>

</variablelist>

Definition at line 67 of file EST_Relation.h.

## Member Typedef Documentation

## Iterator

typedef EST_Relation_Iterator EST_Relation::Iterator

Iteration

Definition at line 190 of file EST_Relation.h.

## Constructor & Destructor Documentation

## EST_Relation() [1/3]

EST_Relation::EST_Relation | ( |  | ) |

default constructor

Definition at line 57 of file EST_Relation.cc.

## EST_Relation() [2/3]

EST_Relation::EST_Relation | ( | const EST_String & | name | ) |

Constructor which sets name of relation

Definition at line 49 of file EST_Relation.cc.

## EST_Relation() [3/3]

EST_Relation::EST_Relation | ( | const EST_Relation & | r | ) |

inline

Constructor which copies relation r

Definition at line 98 of file EST_Relation.h.

## ~EST_Relation()

EST_Relation::~EST_Relation | ( |  | ) |

default destructor

Definition at line 132 of file EST_Relation.cc.

## Member Function Documentation

## evaluate_item_features()

void EST_Relation::evaluate_item_features | ( |  | ) |

Evaluate the relation's feature functions Evaluate the feature functions of all the items in the relation

Definition at line 147 of file EST_Relation.cc.

## clear()

void EST_Relation::clear | ( |  | ) |

Clear the relation of items

Definition at line 153 of file EST_Relation.cc.

## utt()

EST_Utterance * EST_Relation::utt | ( | void |  | ) |

inline

Return the <link linkend="est-utterance">EST_Utterance</link> to which this relation belongs

Definition at line 115 of file EST_Relation.h.

## set_utt()

void EST_Relation::set_utt | ( | EST_Utterance * | u | ) |

inline

Set the <link linkend="est-utterance">EST_Utterance</link> to which this relation belongs

Definition at line 119 of file EST_Relation.h.

## name()

const EST_String & EST_Relation::name | ( |  | ) | const

inline

Return the name of the relation

Definition at line 122 of file EST_Relation.h.

## head()

EST_Item * EST_Relation::head | ( |  | ) | const

inline

Return the head (first) item of the relation

Definition at line 125 of file EST_Relation.h.

## root()

EST_Item * EST_Relation::root | ( |  | ) | const

inline

Return the root item of the relation

Definition at line 128 of file EST_Relation.h.

## tail()

EST_Item * EST_Relation::tail | ( |  | ) | const

inline

Return the tail (last) item of the relation

Definition at line 131 of file EST_Relation.h.

## first()

EST_Item * EST_Relation::first | ( |  | ) | const

inline

Definition at line 134 of file EST_Relation.h.

## rlast()

EST_Item * EST_Relation::rlast | ( |  | ) | const

inline

Definition at line 135 of file EST_Relation.h.

## length()

int EST_Relation::length | ( |  | ) | const

Return the tail (last) item of the relation number of items in this relation

Definition at line 137 of file EST_Relation.cc.

## empty()

int EST_Relation::empty | ( |  | ) | const

inline

return true if relation does not contain any items

Definition at line 145 of file EST_Relation.h.

## remove_item()

void EST_Relation::remove_item | ( | EST_Item * | item | ) |

remove EST_Item <parameter>item</parameter> from relation

Definition at line 165 of file EST_Relation.cc.

## remove_item_feature()

void EST_Relation::remove_item_feature | ( | const EST_String & | name | ) |

remove all occurrences of feature <parameter>name</parameter> from relation's items

Definition at line 174 of file EST_Relation.cc.

## load() [1/3]

EST_read_status EST_Relation::load | ( | const EST_String & | filename,
|  | const EST_String & | type = "esps" )

Load relation from file

Definition at line 620 of file EST_Relation.cc.

## load() [2/3]

EST_read_status EST_Relation::load | ( | EST_TokenStream & | ts,
|  | const EST_TVector< EST_Item_Content * > & | contents )

Load relation from already open tokenstream Load relation from already open tokenstream

Definition at line 306 of file EST_Relation.cc.

## load() [3/3]

EST_read_status EST_Relation::load | ( | const EST_String & | filename,
|  | EST_TokenStream & | ts,
|  | const EST_String & | type )

Load relation from already open tokenstream

Definition at line 596 of file EST_Relation.cc.

## save() [1/4]

EST_write_status EST_Relation::save | ( | const EST_String & | filename,
|  | bool | evaluate_ff = false ) const

Save relation to file

Definition at line 224 of file EST_Relation.cc.

## save() [2/4]

EST_write_status EST_Relation::save | ( | const EST_String & | filename,
|  | const EST_String & | type,
|  | bool | evaluate_ff = false ) const

Save relation to file, evaluating all feature functions before hand

Definition at line 209 of file EST_Relation.cc.

## save() [3/4]

EST_write_status EST_Relation::save | ( | ostream & | outf,
|  | EST_TKVL< void *, int > | contents ) const

Save relation from already open ostream

Definition at line 230 of file EST_Relation.cc.

## save() [4/4]

EST_write_status EST_Relation::save | ( | ostream & | outf,
|  | const EST_String & | type,
|  | bool | evaluate_ff ) const

Save relation from already open ostream

Definition at line 194 of file EST_Relation.cc.

## operator=()

EST_Relation & EST_Relation::operator= | ( | const EST_Relation & | s | ) |

Definition at line 665 of file EST_Relation.cc.

## append() [1/2]

EST_Item * EST_Relation::append | ( | EST_Item * | si | ) |

Definition at line 86 of file EST_Relation.cc.

## append() [2/2]

EST_Item * EST_Relation::append | ( |  | ) |

Definition at line 106 of file EST_Relation.cc.

## prepend() [1/2]

EST_Item * EST_Relation::prepend | ( | EST_Item * | si | ) |

Definition at line 116 of file EST_Relation.cc.

## prepend() [2/2]

EST_Item * EST_Relation::prepend | ( |  | ) |

Definition at line 111 of file EST_Relation.cc.

## Friends And Related Symbol Documentation

## EST_Item

friend class EST_Item

friend

Definition at line 200 of file EST_Relation.h.

## operator<<

ostream & operator<< | ( | ostream & | s,
|  | const EST_Relation & | u )

friend

Definition at line 671 of file EST_Relation.cc.

## Member Data Documentation

## f

EST_Features EST_Relation::f

Features which belong to the relation rather than its items

Definition at line 103 of file EST_Relation.h.

The documentation for this class was generated from the following files:

- include/ling_class/EST_Relation.h
- ling_class/EST_Relation.cc